execute as @e[name=Candyman,type=villager] at @s run kill @e[type=arrow,distance=..4]
execute as @e[tag=batHP,type=bat] at @s run kill @e[type=arrow,distance=..3]

execute as @e[name=Candyman,type=villager] at @s run teleport @s ~ ~ ~ facing entity @p[scores={player=1..}] eyes

#spectate
execute if entity @e[tag=controller,type=armor_stand,tag=specMode] as @a[scores={player=1..},gamemode=spectator] at @s run spectate @p[scores={minigames=1..,player=1..}] @s

#start
execute as @e[type=armor_stand,tag=controller,tag=playingMinigame3] run scoreboard players add @s minigameTime 1

execute as @e[type=armor_stand,tag=controller,scores={minigameTime=1}] run title @a[scores={minigames=1..}] times 20 80 20 
execute as @e[type=armor_stand,tag=controller,scores={minigameTime=1}] as @a[scores={minigames=1..}] at @s run playsound entity.ender_dragon.growl master @s ~ ~ ~ 1000 0.5
execute as @e[type=armor_stand,tag=controller,scores={minigameTime=1}] run title @a[scores={minigames=1..}] title [{"text":"Boss Battle","color":"dark_purple","bold":"true"}]
execute as @e[type=armor_stand,tag=controller,scores={minigameTime=1}] run title @a[scores={minigames=1..}] subtitle [{"text":"Candyman","color":"light_purple","bold":"true"}]

#actionbar and health
scoreboard players set @e[tag=controller] candymanHealth 0
execute as @e[tag=batHP,type=bat] run scoreboard players add @e[tag=controller] candymanHealth 1
execute as @e[name=Candyman,type=villager] run scoreboard players add @e[tag=controller] candymanHealth 1

execute as @e[type=armor_stand,tag=controller,tag=playingMinigame3,scores={candymanHealth=4}] run title @a actionbar [{"text":"♥♥♥♥","color":"red","bold":"true"},{"text":" | ","color":"dark_gray","bold":"false"},{"score":{"name":"@e[tag=controller]","objective":"colorTime"},"color":"light_purple","bold":"false"},{"text":" | ","color":"dark_gray","bold":"false"},{"text":"Kill the hanging bats","color":"dark_purple","bold":"false"}]
execute as @e[type=armor_stand,tag=controller,tag=playingMinigame3,scores={candymanHealth=3}] run title @a actionbar [{"text":"♥♥♥","color":"red","bold":"true"},{"text":"♥","color":"dark_gray","bold":"true"},{"text":" | ","color":"dark_gray","bold":"false"},{"score":{"name":"@e[tag=controller]","objective":"colorTime"},"color":"light_purple","bold":"false"},{"text":" | ","color":"dark_gray","bold":"false"},{"text":"Kill the hanging bats","color":"dark_purple","bold":"false"}]
execute as @e[type=armor_stand,tag=controller,tag=playingMinigame3,scores={candymanHealth=2}] run title @a actionbar [{"text":"♥♥","color":"red","bold":"true"},{"text":"♥♥","color":"dark_gray","bold":"true"},{"text":" | ","color":"dark_gray","bold":"false"},{"score":{"name":"@e[tag=controller]","objective":"colorTime"},"color":"light_purple","bold":"false"},{"text":" | ","color":"dark_gray","bold":"false"},{"text":"Kill the hanging bats","color":"dark_purple","bold":"false"}]
execute as @e[type=armor_stand,tag=controller,tag=playingMinigame3,scores={candymanHealth=1}] run title @a actionbar [{"text":"♥","color":"red","bold":"true"},{"text":"♥♥♥","color":"dark_gray","bold":"true"},{"text":" | ","color":"dark_gray","bold":"false"},{"score":{"name":"@e[tag=controller]","objective":"colorTime"},"color":"light_purple","bold":"false"},{"text":" | ","color":"dark_gray","bold":"false"},{"text":"Candyman is now vulnerable!","color":"dark_purple","bold":"false"}]

#color block mechanics
tag @e[tag=candymanBlock] remove air
execute as @e[type=armor_stand,tag=controller,scores={colorTime=0}] as @e[tag=candymanBlock,type=area_effect_cloud] at @s if block ~ ~ ~ air run tag @s add air

execute as @e[type=armor_stand,tag=controller,scores={minigameTime=61..}] as @e[tag=candymanBlock,limit=1,tag=air] run scoreboard players remove @e[tag=controller] resetTime 1
execute as @e[type=armor_stand,tag=controller,scores={minigameTime=61..,resetTime=100}] run scoreboard players remove @s colorTime 1

execute as @e[type=armor_stand,tag=controller,scores={minigameTime=61,colorAdvance=0}] run function single:resetcandymanblocks
execute as @e[type=armor_stand,tag=controller,scores={minigameTime=61,colorAdvance=0}] run function single:candymancheck
execute as @e[type=armor_stand,tag=controller,scores={minigameTime=61,colorAdvance=0}] run function single:candymancannons

execute as @e[type=armor_stand,tag=controller,scores={resetTime=0}] run function single:resetcandymanblocks
execute as @e[type=armor_stand,tag=controller,scores={resetTime=0}] run function single:candymancheck
execute as @e[type=armor_stand,tag=controller,scores={resetTime=0}] run function single:candymancannons

execute as @e[type=armor_stand,tag=controller,scores={colorTime=0}] run function single:candymansetair

#candyman movement
execute as @e[type=armor_stand,tag=controller,scores={minigameTime=61..,bossAdvance=1..}] run scoreboard players add @e[type=villager,name=Candyman] moveTime 1

execute as @e[type=villager,name=Candyman,tag=right] at @s run tp @s ~0.1 ~ ~ 180 0
execute as @e[type=villager,name=Candyman,tag=left] at @s run tp @s ~-0.1 ~ ~ 180 0

execute as @e[tag=controller,type=armor_stand,scores={bossAdvance=1}] as @e[type=villager,name=Candyman,scores={moveTime=100..}] at @s run summon fireball ~ ~1 ~-1 {Motion:[0.0,0.0,-1.9],direction:[0.0,0.0,-1.9],ExplosionPower:1}
execute as @e[tag=controller,type=armor_stand,scores={bossAdvance=2..}] as @e[type=villager,name=Candyman,scores={moveTime=100..}] at @s run summon fireball ~ ~1 ~-1 {Motion:[0.0,0.0,-1.9],direction:[0.0,0.0,-2.0],ExplosionPower:2}
execute as @e[type=villager,name=Candyman,scores={moveTime=100..}] run scoreboard players set @s moveTime 0

execute as @e[type=villager,name=Candyman,tag=right] at @s if block ~1 ~ ~ quartz_block run tag @s add left
execute as @e[type=villager,name=Candyman,tag=right] at @s if block ~1 ~ ~ quartz_block run tag @s remove right

execute as @e[type=villager,name=Candyman,tag=left] at @s if block ~-1 ~ ~ quartz_block run tag @s add right
execute as @e[type=villager,name=Candyman,tag=left] at @s if block ~-1 ~ ~ quartz_block run tag @s remove left

#replace killed bats with barrier block and add to bossAdvance
execute as @e[tag=candymanBatSpawn,type=area_effect_cloud] at @s if block ~ ~ ~ air unless entity @e[tag=batHP,type=bat,distance=..2] run scoreboard players add @e[tag=controller,type=armor_stand] bossAdvance 1
execute as @e[tag=candymanBatSpawn,type=area_effect_cloud] at @s if block ~ ~ ~ air unless entity @e[tag=batHP,type=bat,distance=..2] run scoreboard players set @e[tag=controller,type=armor_stand] colorAdvance 0
execute as @e[tag=controller,scores={bossAdvance=1..},type=armor_stand] as @e[tag=candymanBatSpawn,type=area_effect_cloud] at @s if block ~ ~ ~ air unless entity @e[tag=batHP,type=bat,distance=..2] run tag @e[name=Candyman,type=villager,tag=!right,tag=!left] add right
execute as @e[tag=controller,scores={bossAdvance=1},type=armor_stand] as @e[tag=candymanBatSpawn,type=area_effect_cloud] at @s if block ~ ~ ~ air unless entity @e[tag=batHP,type=bat,distance=..2] run tellraw @a [{"text":"Candyman: ","color":"gold","bold":"true"},{"text":"You think you're so tough, huh? I haven't even started yet!","color":"gold","bold":"false"}]
execute as @e[tag=controller,scores={bossAdvance=2},type=armor_stand] as @e[tag=candymanBatSpawn,type=area_effect_cloud] at @s if block ~ ~ ~ air unless entity @e[tag=batHP,type=bat,distance=..2] run tellraw @a [{"text":"Candyman: ","color":"gold","bold":"true"},{"text":"You're only making matters worse! I'm progressively building up my strength!","color":"gold","bold":"false"}]
execute as @e[tag=controller,scores={bossAdvance=3},type=armor_stand] as @e[tag=candymanBatSpawn,type=area_effect_cloud] at @s if block ~ ~ ~ air unless entity @e[tag=batHP,type=bat,distance=..2] run tellraw @a [{"text":"Candyman: ","color":"gold","bold":"true"},{"text":"You think you're winning, but I feel as powerful as ever! No one beats this minigame!","color":"gold","bold":"false"}]
execute as @e[tag=candymanBatSpawn,type=area_effect_cloud] at @s if block ~ ~ ~ air unless entity @e[tag=batHP,distance=..2,type=bat] as @a at @s run playsound entity.chicken.egg master @s ~ ~ ~ 1000
execute as @e[tag=candymanBatSpawn,type=area_effect_cloud] at @s if block ~ ~ ~ air unless entity @e[tag=batHP,distance=..2,type=bat] run setblock ~ ~ ~ barrier

#kill inGround trident
kill @e[type=trident,nbt={inGround:1b}]

#no entering zombie spawn rooms or candyman room
execute as @e[type=arrow,x=210,y=5,z=-730,dx=19,dy=10,dz=10] run kill @s
execute as @e[type=!trident,type=!fireball,type=!villager,type=!bat,type=!area_effect_cloud,x=210,y=5,z=-730,dx=19,dy=10,dz=10] at @s run tp @s ~ ~ -731

execute as @e[type=!trident,type=!zombie,type=!fireball,type=!arrow,x=230,y=5,z=-733,dx=3,dy=1,dz=0] at @s run tp @s 229 ~ ~
execute as @e[type=!trident,type=!zombie,type=!fireball,type=!arrow,x=230,y=5,z=-741,dx=3,dy=2,dz=1] at @s run tp @s 229 ~ ~
execute as @e[type=!trident,type=!zombie,type=!fireball,type=!arrow,x=230,y=5,z=-748,dx=3,dy=1,dz=0] at @s run tp @s 229 ~ ~

execute as @e[type=!trident,type=!zombie,type=!fireball,type=!arrow,x=227,y=5,z=-751,dx=0,dy=1,dz=-3] at @s run tp @s ~ ~ -750
execute as @e[type=!trident,type=!zombie,type=!fireball,type=!arrow,x=219,y=5,z=-751,dx=1,dy=2,dz=-3] at @s run tp @s ~ ~ -750
execute as @e[type=!trident,type=!zombie,type=!fireball,type=!arrow,x=212,y=5,z=-751,dx=0,dy=1,dz=-3] at @s run tp @s ~ ~ -750

execute as @e[type=!trident,type=!zombie,type=!fireball,type=!arrow,x=209,y=5,z=-748,dx=-3,dy=1,dz=0] at @s run tp @s 210 ~ ~
execute as @e[type=!trident,type=!zombie,type=!fireball,type=!arrow,x=209,y=5,z=-741,dx=-3,dy=2,dz=1] at @s run tp @s 210 ~ ~
execute as @e[type=!trident,type=!zombie,type=!fireball,type=!arrow,x=209,y=5,z=-733,dx=-3,dy=1,dz=0] at @s run tp @s 210 ~ ~

#chasing bats
execute as @e[tag=batChase,type=bat] at @s facing entity @p[scores={minigames=1..}] eyes run teleport @s ^ ^-0.3 ^0.2 facing entity @p[scores={minigames=1..}] eyes

#wither skeleton levitation effect
execute as @a[scores={minigames=1..},nbt={ActiveEffects:[{Id:20b}]}] run effect give @s levitation 3 1 true
execute as @a[scores={minigames=1..},nbt={ActiveEffects:[{Id:20b}]}] run effect clear @s wither

#gold
#zombie
execute as @a[scores={kill1=1..}] run scoreboard players add @s gold 1
execute as @a[scores={kill1=1..}] run tellraw @s [{"text":"+1 gold","color":"yellow"}]
execute as @a[scores={kill1=1..}] run scoreboard players reset @s kill1

execute as @a[scores={kill2=1..}] run scoreboard players add @s gold 1
execute as @a[scores={kill2=1..}] run tellraw @s [{"text":"+1 gold","color":"yellow"}]
execute as @a[scores={kill2=1..}] run scoreboard players reset @s kill2

execute as @a[scores={kill3=1..}] run scoreboard players add @s gold 1
execute as @a[scores={kill3=1..}] run tellraw @s [{"text":"+1 gold","color":"yellow"}]
execute as @a[scores={kill3=1..}] run scoreboard players reset @s kill3

execute as @a[scores={kill4=1..}] run scoreboard players add @s gold 2
execute as @a[scores={kill4=1..}] run tellraw @s [{"text":"+2 gold","color":"yellow"}]
execute as @a[scores={kill4=1..}] run scoreboard players reset @s kill4

#kill wither skeleton
execute as @a[scores={killWS=1..}] run give @s trident{Unbreakable:1,HideFlags:4}
execute as @a[scores={killWS=1..}] run tellraw @a [{"text":"","extra":[{"selector":"@a[scores={killWS=1..}]"}]},{"text":" has received a Trident","color":"green","bold":"true"}]
execute as @a[scores={killWS=1..}] as @a at @s run playsound entity.player.levelup master @s ~ ~ ~ 1000
execute as @a[scores={killWS=1..}] run scoreboard players reset @s killWS

#kill entities on glowstone
execute as @e[tag=candymanWitherSkeleton,type=wither_skeleton] at @s if block ~ ~-1 ~ glowstone run kill @s
execute as @e[tag=candymanCreeper,type=creeper] at @s if block ~ ~-1 ~ glowstone run kill @s
execute as @e[tag=candymanZombie,type=zombie] at @s if block ~ ~-1 ~ glowstone run kill @s
execute as @e[tag=candymanSilverfish,type=silverfish] at @s if block ~ ~-1 ~ glowstone run kill @s

#vulnerable candyman
execute unless entity @e[tag=batHP,type=bat] run data merge entity @e[name=Candyman,type=villager,limit=1,tag=!vulnerable] {Health:1,Invulnerable:0,Attributes:[{Name:"generic.knockbackResistance",Base:1f},{Name:"generic.movementSpeed",Base:0f},{Name:"generic.maxHealth",Base:1f}]}
execute unless entity @e[tag=batHP,type=bat] run tag @e[name=Candyman,type=villager,tag=!vulnerable] add vulnerable

#hit glowstone
execute as @a[scores={minigames=1..}] at @s if block ~ ~-1 ~ glowstone run tag @s add hitGlowstone
execute as @a[scores={minigames=1..}] at @s if block ~ ~-1 ~ glowstone run function single:minigame3glowstone

#lose
execute unless entity @a[scores={minigames=1..}] run function single:minigame3end

#won
execute unless entity @e[name=Candyman] run tag @e[tag=controller] add won
execute unless entity @e[name=Candyman] run function single:minigame3end